## tahoe-lafs 1.5.0

=== Makefile ===

# NOTE: this Makefile requires GNU make

default: build

PYTHON=python
export PYTHON

# setup.py will extend sys.path to include our support/lib/... directory
# itself. It will also create it in the beginning of the 'develop' command.

PP=$(shell $(PYTHON) setup.py -q show_pythonpath)
RUNPP=$(PYTHON) setup.py run_with_pythonpath

.PHONY: make-version build

# The 'darcsver' setup.py command comes in the 'darcsver' package:
# http://pypi.python.org/pypi/darcsver It is necessary only if you want to
# automatically produce a new _version.py file from the current darcs history.
make-version:
	$(PYTHON) ./setup.py darcsver --count-all-patches

# We want src/allmydata/_version.py to be up-to-date, but it's a fairly
# expensive operation (about 6 seconds on a just-before-0.7.0 tree, probably
# because of the 332 patches since the last tag), and we've removed the need
# for an explicit 'build' step by removing the C code from src/allmydata and
# by running everything in place. It would be neat to do:
#
#src/allmydata/_version.py: _darcs/patches
#	$(MAKE) make-version
#
# since that would update the embedded version string each time new darcs
# patches were pulled, but 1) this would break non-darcs trees (i.e. building
# from an exported tarball), and 2) without an obligatory 'build' step this
# rule wouldn't be run frequently enought anyways.
#
# So instead, I'll just make sure that we update the version at least once
# when we first start using the tree, and again whenever an explicit
# 'make-version' is run, since then at least the developer has some means to
# update things. It would be nice if 'make clean' deleted any
# automatically-generated _version.py too, so that 'make clean; make all'
# could be useable as a "what the heck is going on, get me back to a clean
# state', but we need 'make clean' to work on non-darcs trees without
# destroying useful information.

.built:
	$(MAKE) build

src/allmydata/_version.py:
	$(MAKE) make-version

# c.f. ticket #455, there is a problem in the intersection of setuptools,
# twisted's setup.py, and nevow's setup.py . A Tahoe build, to satisfy its
# dependencies, may try to build both Twisted and Nevow. If both of these
# occur during the same invocation of 'setup.py develop', then the Nevow
# build will fail with an "ImportError: No module named components". Running
# the build a second time will succeed. Until there is a new version of
# setuptools which properly sandboxes sys.modules (or a new version of nevow
# which doesn't import twisted during its build, or a new version of twisted
# which doesn't import itself during its build), we just build tahoe twice
# and ignore the errors from the first pass. Updated 16-Sep-2008: now we need
# three invocations.

build: src/allmydata/_version.py
	$(PYTHON) setup.py build
	touch .built

# 'make install' will do the following:
#   build+install tahoe (probably to /usr/lib/pythonN.N/site-packages)
# 'make install PREFIX=/usr/local/stow/tahoe-N.N' will do the same, but to
# a different location

install: src/allmydata/_version.py
ifdef PREFIX
	mkdir -p $(PREFIX)
	$(PYTHON) ./setup.py install --single-version-externally-managed \
           --prefix=$(PREFIX) --record=./tahoe.files
else
	$(PYTHON) ./setup.py install --single-version-externally-managed
endif


# TESTING

.PHONY: signal-error-deps test test-figleaf quicktest quicktest-figleaf
.PHONY: figleaf-output get-old-figleaf-coverage figleaf-delta-output


signal-error-deps:
	@echo
	@echo
	@echo "ERROR: Not all of Tahoe's dependencies are in place.  Please see docs/install.html for help on installing dependencies."
	@echo
	@echo
	exit 1

check-auto-deps:
	$(PYTHON) setup.py -q check_auto_deps || $(MAKE) signal-error-deps

.checked-deps:
	$(MAKE) check-auto-deps
	touch .checked-deps

# you can use 'make test TEST=allmydata.test.test_introducer' to run just
# test_introducer. TEST=allmydata.test.test_client.Basic.test_permute works
# too.
TEST=allmydata

# use 'make test TRIALARGS=--reporter=bwverbose' from buildbot, to
# suppress the ansi color sequences

test: build src/allmydata/_version.py
	$(PYTHON) setup.py test $(TRIALARGS) -s $(TEST)

fuse-test: .built .checked-deps
	$(RUNPP) -d contrib/fuse -p -c runtests.py

test-figleaf: build src/allmydata/_version.py
	rm -f .figleaf
	$(PYTHON) setup.py trial --reporter=bwverbose-figleaf -s $(TEST)

quicktest:
	$(PYTHON) misc/run-with-pythonpath.py trial $(TRIALARGS) $(TEST)

quicktest-figleaf:
	rm -f .figleaf
	$(PYTHON) misc/run-with-pythonpath.py trial --reporter=bwverbose-figleaf $(TEST)

figleaf-output:
	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes"
	cp .figleaf coverage-html/figleaf.pickle
	@echo "now point your browser at coverage-html/index.html"

# use these two targets to compare this coverage against the previous run.
# The deltas only work if the old test was run in the same directory, since
# it compares absolute filenames.
get-old-figleaf-coverage:
	wget --progress=dot -O old.figleaf http://allmydata.org/tahoe-figleaf/current/figleaf.pickle

figleaf-delta-output:
	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes -o old.figleaf"
	cp .figleaf coverage-html/figleaf.pickle
	@echo "now point your browser at coverage-html/index.html"

# after doing test-figleaf and figleaf-output, point your browser at
# coverage-html/index.html

.PHONY: upload-figleaf .figleaf.el pyflakes count-lines
.PHONY: check-memory check-memory-once check-speed check-grid
.PHONY: repl test-darcs-boringfile test-clean clean find-trailing-spaces

# 'upload-figleaf' is meant to be run with an UPLOAD_TARGET=host:/dir setting
ifdef UPLOAD_TARGET

ifndef UPLOAD_HOST
$(error UPLOAD_HOST must be set when using UPLOAD_TARGET)
endif
ifndef COVERAGEDIR
$(error COVERAGEDIR must be set when using UPLOAD_TARGET)
endif

upload-figleaf:
	rsync -a coverage-html/ $(UPLOAD_TARGET)
	ssh $(UPLOAD_HOST) make update-tahoe-figleaf COVERAGEDIR=$(COVERAGEDIR)
else
upload-figleaf:
	echo "this target is meant to be run with UPLOAD_TARGET=host:/path/"
	false
endif

.figleaf.el: .figleaf
	$(RUNPP) -p -c "misc/figleaf2el.py .figleaf src"

pyflakes:
	$(PYTHON) -OOu `which pyflakes` src/allmydata |sort |uniq

count-lines:
	@echo -n "files: "
	@find src -name '*.py' |grep -v /build/ |wc --lines
	@echo -n "lines: "
	@cat `find src -name '*.py' |grep -v /build/` |wc --lines
	@echo -n "TODO: "
	@grep TODO `find src -name '*.py' |grep -v /build/` | wc --lines

check-memory: .built
	rm -rf _test_memory
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py upload"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py upload-self"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py upload-POST"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py download"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py download-GET"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py download-GET-slow"
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py receive"

check-memory-once: .built
	rm -rf _test_memory
	$(RUNPP) -p -c "src/allmydata/test/check_memory.py $(MODE)"

# The check-speed target uses a pre-established client node to run a canned
# set of performance tests against a test network that is also
# pre-established (probably on a remote machine). Provide it with the path to
# a local directory where this client node has been created (and populated
# with the necessary FURLs of the test network). This target will start that
# client with the current code and then run the tests. Afterwards it will
# stop the client.
#
# The 'sleep 5' is in there to give the new client a chance to connect to its
# storageservers, since check_speed.py has no good way of doing that itself.

check-speed: .built
	if [ -z '$(TESTCLIENTDIR)' ]; then exit 1; fi
	@echo "stopping any leftover client code"
	-$(PYTHON) bin/tahoe stop $(TESTCLIENTDIR)
	$(PYTHON) bin/tahoe start $(TESTCLIENTDIR)
	sleep 5
	$(PYTHON) src/allmydata/test/check_speed.py $(TESTCLIENTDIR)
	$(PYTHON) bin/tahoe stop $(TESTCLIENTDIR)

# The check-grid target also uses a pre-established client node, along with a
# long-term directory that contains some well-known files. See the docstring
# in src/allmydata/test/check_grid.py to see how to set this up.
check-grid: .built
	if [ -z '$(TESTCLIENTDIR)' ]; then exit 1; fi
	$(PYTHON) src/allmydata/test/check_grid.py $(TESTCLIENTDIR) bin/tahoe

# 'make repl' is a simple-to-type command to get a Python interpreter loop
# from which you can type 'import allmydata'
repl:
	$(RUNPP) -p

test-darcs-boringfile:
	$(MAKE)
	$(PYTHON) misc/test-darcs-boringfile.py

test-clean:
	find . |grep -vEe "allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.old
	$(MAKE)
	$(MAKE) clean
	find . |grep -vEe "allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.new
	diff allfiles.tmp.old allfiles.tmp.new

clean:
	rm -rf build _trial_temp _test_memory .checked-deps .built
	rm -f debian
	rm -f `find src/allmydata -name '*.so' -or -name '*.pyc'`
	rm -rf src/allmydata_tahoe.egg-info
	rm -rf support dist
	rm -rf setuptools*.egg *.pyc darcsver*.egg pyutil*.egg
	rm -rf misc/dependencies/build misc/dependencies/temp
	rm -rf misc/dependencies/tahoe_deps.egg-info
	rm -f bin/tahoe bin/tahoe-script.py

find-trailing-spaces:
	$(PYTHON) misc/find-trailing-spaces.py -r src

# The test-desert-island target grabs the tahoe-deps tarball, unpacks it,
# does a build, then asserts that the build did not try to download anything
# as it ran. Invoke this on a new tree, or after a 'clean', to make sure the
# support/lib/ directory is gone.

fetch-and-unpack-deps:
	test -f tahoe-deps.tar.gz || wget http://allmydata.org/source/tahoe/deps/tahoe-deps.tar.gz
	rm -rf tahoe-deps
	tar xf tahoe-deps.tar.gz

test-desert-island:
	$(MAKE) fetch-and-unpack-deps
	$(MAKE) 2>&1 | tee make.out
	$(PYTHON) misc/check-build.py make.out no-downloads


# TARBALL GENERATION
.PHONY: tarballs upload-tarballs
tarballs:
	$(MAKE) make-version
	$(PYTHON) setup.py sdist --formats=bztar,gztar,zip
	$(PYTHON) setup.py sdist --sumo --formats=bztar,gztar,zip

upload-tarballs:
	for f in dist/allmydata-tahoe-*; do \
	 xfer-client --furlfile ~/.tahoe-tarball-upload.furl $$f; \
	done

# DEBIAN PACKAGING

VER=$(shell $(PYTHON) misc/get-version.py)
DEBCOMMENTS="'make deb' build"

show-version:
	@echo $(VER)
show-pp:
	@echo $(PP)

.PHONY: setup-deb deb-ARCH is-known-debian-arch
.PHONY: deb-etch deb-lenny deb-sid
.PHONY: deb-edgy deb-feisty deb-gutsy deb-hardy deb-intrepid deb-jaunty

# we use misc/$TAHOE_ARCH/debian

deb-etch:      # py2.4
	$(MAKE) deb-ARCH ARCH=etch TAHOE_ARCH=etch
deb-lenny:     # py2.5
	$(MAKE) deb-ARCH ARCH=lenny TAHOE_ARCH=lenny
deb-sid:
	$(MAKE) deb-ARCH ARCH=sid TAHOE_ARCH=sid

deb-edgy:     # py2.4
	$(MAKE) deb-ARCH ARCH=edgy TAHOE_ARCH=etch
deb-feisty:   # py2.5
	$(MAKE) deb-ARCH ARCH=feisty TAHOE_ARCH=lenny
deb-gutsy:    # py2.5
	$(MAKE) deb-ARCH ARCH=gutsy TAHOE_ARCH=lenny
deb-hardy:    # py2.5
	$(MAKE) deb-ARCH ARCH=hardy TAHOE_ARCH=lenny
deb-intrepid: # py2.5
	$(MAKE) deb-ARCH ARCH=intrepid TAHOE_ARCH=lenny
deb-jaunty:   # py2.6
	$(MAKE) deb-ARCH ARCH=jaunty TAHOE_ARCH=lenny



# we know how to handle the following debian architectures
KNOWN_DEBIAN_ARCHES := etch lenny sid  edgy feisty gutsy hardy intrepid jaunty

ifeq ($(findstring x-$(ARCH)-x,$(foreach arch,$(KNOWN_DEBIAN_ARCHES),"x-$(arch)-x")),)
is-known-debian-arch:
	@echo "ARCH must be set when using setup-deb or deb-ARCH"
	@echo "I know how to handle:" $(KNOWN_DEBIAN_ARCHES)
	false
else
is-known-debian-arch:
	true
endif

ifndef TAHOE_ARCH
TAHOE_ARCH=$(ARCH)
endif

setup-deb: is-known-debian-arch
	rm -f debian
	ln -s misc/$(TAHOE_ARCH)/debian debian
	chmod +x debian/rules

# etch (current debian stable) has python-simplejson-1.3, which doesn't
#  support indent=
# sid (debian unstable) currently has python-simplejson 1.7.1
# edgy has 1.3, which doesn't support indent=
# feisty has 1.4, which supports indent= but emits a deprecation warning
# gutsy has 1.7.1
#

=== mac/Makefile ===

.PHONY: all dist build diskimage upload cleanup clean

all: build

dist: build diskimage upload cleanup

build:
	rsync -av ` sw_vers -productVersion | sed -e 's/^\(10\.[0-9]*\)\..*$$/\1/' `/ ./
	ln -sf ../contrib/fuse/impl_c/blackmatch.py tahoefuse.py
	python setup.py py2app --no-chdir

diskimage:
	mv dist Allmydata-$(VERSION)
	hdiutil create -ov -srcfolder Allmydata-$(VERSION) allmydata-rw.dmg
	hdiutil convert -ov allmydata-rw.dmg -format UDRO -o allmydata-ro.dmg
	hdiutil convert -ov allmydata-ro.dmg -format UDZO -o Allmydata-$(VERSION).dmg
	hdiutil internet-enable -yes Allmydata-$(VERSION).dmg
	rm -r Allmydata-$(VERSION) allmydata-rw.dmg allmydata-ro.dmg

ifdef UPLOAD_DEST_FURLFILE
# N.B.: xfer-client.py requires foolscap, so we hack up PYTHONPATH to improve
# the chances of finding it (using the one that we just built)
upload:
	chmod a+r Allmydata-$(VERSION).dmg
	PYTHONPATH=$(PYTHONPATH):../support/lib/python2.5/site-packages \
	 python ../misc/xfer-client.py --furlfile $(UPLOAD_DEST_FURLFILE) \
	 Allmydata-$(VERSION).dmg
else
upload:
	$(error UPLOAD_DEST_FURLFILE must be set when using upload target. e.g. make upload UPLOAD_DEST_FURLFILE=~/.upload.furl)
endif

cleanup:
	rm Allmydata-$(VERSION).dmg

clean:
	rm -rf build dist

## tahoe-lafs 1.6.1

=== Makefile ===
--- 
+++ 
@@ -30,9 +30,8 @@
 #	$(MAKE) make-version
 #
 # since that would update the embedded version string each time new darcs
-# patches were pulled, but 1) this would break non-darcs trees (i.e. building
-# from an exported tarball), and 2) without an obligatory 'build' step this
-# rule wouldn't be run frequently enought anyways.
+# patches were pulled, but without an obligatory 'build' step this rule
+# wouldn't be run frequently enough anyways.
 #
 # So instead, I'll just make sure that we update the version at least once
 # when we first start using the tree, and again whenever an explicit
@@ -82,8 +81,8 @@
 
 # TESTING
 
-.PHONY: signal-error-deps test test-figleaf quicktest quicktest-figleaf
-.PHONY: figleaf-output get-old-figleaf-coverage figleaf-delta-output
+.PHONY: signal-error-deps test test-coverage quicktest quicktest-coverage
+.PHONY: coverage-output get-old-coverage-coverage coverage-delta-output
 
 
 signal-error-deps:
@@ -115,41 +114,55 @@
 fuse-test: .built .checked-deps
 	$(RUNPP) -d contrib/fuse -p -c runtests.py
 
-test-figleaf: build src/allmydata/_version.py
-	rm -f .figleaf
-	$(PYTHON) setup.py trial --reporter=bwverbose-figleaf -s $(TEST)
+test-coverage: build src/allmydata/_version.py
+	rm -f .coverage
+	$(PYTHON) setup.py trial --reporter=bwverbose-coverage -s $(TEST)
 
 quicktest:
 	$(PYTHON) misc/run-with-pythonpath.py trial $(TRIALARGS) $(TEST)
 
-quicktest-figleaf:
-	rm -f .figleaf
-	$(PYTHON) misc/run-with-pythonpath.py trial --reporter=bwverbose-figleaf $(TEST)
-
-figleaf-output:
-	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes"
-	cp .figleaf coverage-html/figleaf.pickle
+# code-coverage: install the "coverage" package from PyPI, do "make
+# quicktest-coverage" to do a unit test run with coverage-gathering enabled,
+# then use "make coverate-output-text" for a brief report, or "make
+# coverage-output" for a pretty HTML report. Also see "make .coverage.el" and
+# misc/coverage.el for emacs integration.
+
+quicktest-coverage:
+	rm -f .coverage
+	$(PYTHON) misc/run-with-pythonpath.py trial --reporter=bwverbose-coverage $(TEST)
+# on my laptop, "quicktest" takes 239s, "quicktest-coverage" takes 304s
+
+COVERAGE_OMIT = --omit /System,/Library,/usr/lib,src/allmydata/test,support
+
+# this is like 'coverage report', but includes lines-uncovered
+coverage-output-text:
+	$(PYTHON) misc/coverage2text.py
+
+coverage-output:
+	rm -rf coverage-html
+	coverage html -d coverage-html $(COVERAGE_OMIT)
+	cp .coverage coverage-html/coverage.data
 	@echo "now point your browser at coverage-html/index.html"
 
-# use these two targets to compare this coverage against the previous run.
-# The deltas only work if the old test was run in the same directory, since
-# it compares absolute filenames.
-get-old-figleaf-coverage:
-	wget --progress=dot -O old.figleaf http://allmydata.org/tahoe-figleaf/current/figleaf.pickle
-
-figleaf-delta-output:
-	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes -o old.figleaf"
-	cp .figleaf coverage-html/figleaf.pickle
-	@echo "now point your browser at coverage-html/index.html"
-
-# after doing test-figleaf and figleaf-output, point your browser at
-# coverage-html/index.html
-
-.PHONY: upload-figleaf .figleaf.el pyflakes count-lines
+## use these two targets to compare this coverage against the previous run.
+## The deltas only work if the old test was run in the same directory, since
+## it compares absolute filenames.
+#get-old-figleaf-coverage:
+#	wget --progress=dot -O old.figleaf http://allmydata.org/tahoe-figleaf/current/figleaf.pickle
+#
+#figleaf-delta-output:
+#	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes -o old.figleaf"
+#	cp .figleaf coverage-html/figleaf.pickle
+#	@echo "now point your browser at coverage-html/index.html"
+
+.PHONY: upload-coverage .coverage.el pyflakes count-lines
 .PHONY: check-memory check-memory-once check-speed check-grid
 .PHONY: repl test-darcs-boringfile test-clean clean find-trailing-spaces
 
-# 'upload-figleaf' is meant to be run with an UPLOAD_TARGET=host:/dir setting
+.coverage.el: .coverage
+	$(PYTHON) misc/coverage2el.py
+
+# 'upload-coverage' is meant to be run with an UPLOAD_TARGET=host:/dir setting
 ifdef UPLOAD_TARGET
 
 ifndef UPLOAD_HOST
@@ -159,17 +172,15 @@
 $(error COVERAGEDIR must be set when using UPLOAD_TARGET)
 endif
 
-upload-figleaf:
+upload-coverage:
 	rsync -a coverage-html/ $(UPLOAD_TARGET)
-	ssh $(UPLOAD_HOST) make update-tahoe-figleaf COVERAGEDIR=$(COVERAGEDIR)
+	ssh $(UPLOAD_HOST) make update-tahoe-coverage COVERAGEDIR=$(COVERAGEDIR)
 else
-upload-figleaf:
+upload-coverage:
 	echo "this target is meant to be run with UPLOAD_TARGET=host:/path/"
 	false
 endif
 
-.figleaf.el: .figleaf
-	$(RUNPP) -p -c "misc/figleaf2el.py .figleaf src"
 
 pyflakes:
 	$(PYTHON) -OOu `which pyflakes` src/allmydata |sort |uniq
@@ -223,6 +234,9 @@
 	if [ -z '$(TESTCLIENTDIR)' ]; then exit 1; fi
 	$(PYTHON) src/allmydata/test/check_grid.py $(TESTCLIENTDIR) bin/tahoe
 
+bench-dirnode: .built
+	$(RUNPP) -p -c src/allmydata/test/bench_dirnode.py
+
 # 'make repl' is a simple-to-type command to get a Python interpreter loop
 # from which you can type 'import allmydata'
 repl:
@@ -233,19 +247,18 @@
 	$(PYTHON) misc/test-darcs-boringfile.py
 
 test-clean:
-	find . |grep -vEe "allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.old
+	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.old
 	$(MAKE)
 	$(MAKE) clean
-	find . |grep -vEe "allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.new
+	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.new
 	diff allfiles.tmp.old allfiles.tmp.new
 
 clean:
 	rm -rf build _trial_temp _test_memory .checked-deps .built
-	rm -f debian
 	rm -f `find src/allmydata -name '*.so' -or -name '*.pyc'`
 	rm -rf src/allmydata_tahoe.egg-info
 	rm -rf support dist
-	rm -rf setuptools*.egg *.pyc darcsver*.egg pyutil*.egg
+	rm -rf *.egg *.pyc
 	rm -rf misc/dependencies/build misc/dependencies/temp
 	rm -rf misc/dependencies/tahoe_deps.egg-info
 	rm -f bin/tahoe bin/tahoe-script.py
@@ -278,7 +291,7 @@
 
 upload-tarballs:
 	for f in dist/allmydata-tahoe-*; do \
-	 xfer-client --furlfile ~/.tahoe-tarball-upload.furl $$f; \
+	 flappclient --furlfile ~/.tahoe-tarball-upload.furl upload-file $$f; \
 	done
 
 # DEBIAN PACKAGING
@@ -328,23 +341,3 @@
 	@echo "I know how to handle:" $(KNOWN_DEBIAN_ARCHES)
 	false
 else
-is-known-debian-arch:
-	true
-endif
-
-ifndef TAHOE_ARCH
-TAHOE_ARCH=$(ARCH)
-endif
-
-setup-deb: is-known-debian-arch
-	rm -f debian
-	ln -s misc/$(TAHOE_ARCH)/debian debian
-	chmod +x debian/rules
-
-# etch (current debian stable) has python-simplejson-1.3, which doesn't
-#  support indent=
-# sid (debian unstable) currently has python-simplejson 1.7.1
-# edgy has 1.3, which doesn't support indent=
-# feisty has 1.4, which supports indent= but emits a deprecation warning
-# gutsy has 1.7.1
-#

=== debian/changelog ===
tahoe-lafs (1.6.1-0ubuntu2.1) lucid-security; urgency=high

  * SECURITY UPDATE: fix unauthorized deletion (LP: #848476)
    a person who knows the "storage index" that identifies an immutable
    file can cause the server to delete its shares of that file.
    - backported from upstream version 1.8.3
  * http://tahoe-lafs.org/source/tahoe-lafs/snapshots/allmydata-tahoe-1.8.3.zip

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Tue, 13 Sep 2011 22:37:02 +0200

tahoe-lafs (1.6.1-0ubuntu2) lucid; urgency=low

  * Restore files to the binary package by re-instating the package= from
    debian/rules that was deleted too hastily. The empty substiution variable
    meant that python setup.py was told to install the files outside the
    package tmpdir. (LP: #551333)

 -- James Westby <james.westby@ubuntu.com>  Tue, 30 Mar 2010 10:19:27 -0400

tahoe-lafs (1.6.1-0ubuntu1) lucid; urgency=low

  [Jeremy Visser]
  * Update to bugfix release 1.6.1 (LP: #529350).
    - Correct handling of small immutable directories.
    - Improved user interface messages and error reporting.
  * debian/control: bump standards-version to 3.8.4. No changes required.
  * debian/gbp.conf: deleted as it's a temporary file left over
  * debian/watch: fixed to have the correct tarball name and avoid SUMO version

  [Fabrice Coutadeur]
  * Switch to dpkg-source 3.0 (quilt) format
  * debian/reduce_build_dependencies.patch: converted from direct source
    changes done in 1.6.0 to reduce the required dependencies and not download
    them at build time.
  * debian/rules: deleted get-orig-source target as the watch file has been
    fixed

 -- Jeremy Visser <jeremy@visser.name>  Thu, 04 Mar 2010 19:37:54 +1100

tahoe-lafs (1.6.0-0ubuntu1) lucid; urgency=low

  * Update to version 1.6 (LP: #516744).
    - Deep immutable directories.
    - `tahoe backup` now creates immutable directories.
    - `create-node` command added.
    - `create-client` now implies --no-storage.
  * debian/rules: fix find call.

 -- Paul Hummer <paul@ubuntu.com>  Wed, 03 Feb 2010 19:36:39 -0700

tahoe-lafs (1.5.0-0ubuntu1) karmic; urgency=low

  * Initial release (LP: #417136).
  * Relax pycryptopp dependency to 0.5.14, to help it get into Karmic.
  * Add missing license statements.

 -- Zooko O'Whielacronx (Hacker) <zooko@zooko.com>  Thu, 24 Sep 2009 00:00:05 -0600

=== debian/control ===
Source: tahoe-lafs
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Brian Warner <warner@lothar.com>
Build-Depends: debhelper (>= 7), python-support, python-setuptools,
 python (>= 2.5)
XS-Python-Version: >= 2.5
Standards-Version: 3.8.4
Homepage: http://allmydata.org/trac/tahoe

Package: tahoe-lafs
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, python-twisted,
 python-foolscap (>= 0.4.1), python-openssl, python-nevow,
 python-simplejson (>= 1.4), python-zfec (>= 1.1), python-pycryptopp (>= 0.5.14),
 python-setuptools
XB-Python-Version: >= 2.5
Description: Secure distributed filesystem
 Tahoe, the Least Authority File System, is a distributed filesystem that
 features high reliability, strong security properties, and a fine-grained
 sharing model. Files are encrypted, signed, erasure-coded, then distributed
 over multiple servers, such that any (configurable) subset of the servers
 will be sufficient to recover the data. The default 3-of-10 configuration
 tolerates up to 7 server failures before data becomes unrecoverable.
 .
 Tahoe offers "provider-independent security": the confidentiality and
 integrity of your data do not depend upon the behavior of the servers. The
 use of erasure-coding means that reliability and availability depend only
 upon a subset of the servers.
 .
 Tahoe files are accessed through a RESTful web API, a human-oriented web
 server interface, and CLI tools.

## tahoe-lafs 1.7.1

=== Makefile ===
--- 
+++ 
@@ -119,28 +119,22 @@
 	$(PYTHON) setup.py trial --reporter=bwverbose-coverage -s $(TEST)
 
 quicktest:
-	$(PYTHON) misc/run-with-pythonpath.py trial $(TRIALARGS) $(TEST)
+	$(PYTHON) misc/build_helpers/run-with-pythonpath.py trial $(TRIALARGS) $(TEST)
 
 # code-coverage: install the "coverage" package from PyPI, do "make
 # quicktest-coverage" to do a unit test run with coverage-gathering enabled,
 # then use "make coverate-output-text" for a brief report, or "make
 # coverage-output" for a pretty HTML report. Also see "make .coverage.el" and
-# misc/coverage.el for emacs integration.
+# misc/coding_helpers/coverage.el for emacs integration.
 
 quicktest-coverage:
 	rm -f .coverage
-	$(PYTHON) misc/run-with-pythonpath.py trial --reporter=bwverbose-coverage $(TEST)
+	$(PYTHON) misc/build_helpers/run-with-pythonpath.py trial --reporter=bwverbose-coverage $(TEST)
 # on my laptop, "quicktest" takes 239s, "quicktest-coverage" takes 304s
-
-COVERAGE_OMIT = --omit /System,/Library,/usr/lib,src/allmydata/test,support
-
-# this is like 'coverage report', but includes lines-uncovered
-coverage-output-text:
-	$(PYTHON) misc/coverage2text.py
 
 coverage-output:
 	rm -rf coverage-html
-	coverage html -d coverage-html $(COVERAGE_OMIT)
+	coverage html -d coverage-html
 	cp .coverage coverage-html/coverage.data
 	@echo "now point your browser at coverage-html/index.html"
 
@@ -160,7 +154,7 @@
 .PHONY: repl test-darcs-boringfile test-clean clean find-trailing-spaces
 
 .coverage.el: .coverage
-	$(PYTHON) misc/coverage2el.py
+	$(PYTHON) misc/coding_helpers/coverage2el.py
 
 # 'upload-coverage' is meant to be run with an UPLOAD_TARGET=host:/dir setting
 ifdef UPLOAD_TARGET
@@ -244,7 +238,7 @@
 
 test-darcs-boringfile:
 	$(MAKE)
-	$(PYTHON) misc/test-darcs-boringfile.py
+	$(PYTHON) misc/build_helpers/test-darcs-boringfile.py
 
 test-clean:
 	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.old
@@ -255,16 +249,17 @@
 
 clean:
 	rm -rf build _trial_temp _test_memory .checked-deps .built
-	rm -f `find src/allmydata -name '*.so' -or -name '*.pyc'`
+	rm -f `find src *.egg -name '*.so' -or -name '*.pyc'`
 	rm -rf src/allmydata_tahoe.egg-info
 	rm -rf support dist
-	rm -rf *.egg *.pyc
+	rm -rf `ls -d *.egg | grep -vEe"setuptools-|setuptools_trial-|darcsver-"`
+	rm -rf *.pyc
 	rm -rf misc/dependencies/build misc/dependencies/temp
 	rm -rf misc/dependencies/tahoe_deps.egg-info
 	rm -f bin/tahoe bin/tahoe-script.py
 
 find-trailing-spaces:
-	$(PYTHON) misc/find-trailing-spaces.py -r src
+	$(PYTHON) misc/coding_tools/find-trailing-spaces.py -r src
 
 # The test-desert-island target grabs the tahoe-deps tarball, unpacks it,
 # does a build, then asserts that the build did not try to download anything
@@ -274,12 +269,12 @@
 fetch-and-unpack-deps:
 	test -f tahoe-deps.tar.gz || wget http://allmydata.org/source/tahoe/deps/tahoe-deps.tar.gz
 	rm -rf tahoe-deps
-	tar xf tahoe-deps.tar.gz
+	tar xzf tahoe-deps.tar.gz
 
 test-desert-island:
 	$(MAKE) fetch-and-unpack-deps
 	$(MAKE) 2>&1 | tee make.out
-	$(PYTHON) misc/check-build.py make.out no-downloads
+	$(PYTHON) misc/build_helpers/check-build.py make.out no-downloads
 
 
 # TARBALL GENERATION
@@ -290,13 +285,11 @@
 	$(PYTHON) setup.py sdist --sumo --formats=bztar,gztar,zip
 
 upload-tarballs:
-	for f in dist/allmydata-tahoe-*; do \
-	 flappclient --furlfile ~/.tahoe-tarball-upload.furl upload-file $$f; \
-	done
+	@if [ "X${BB_BRANCH}" == "Xtrunk" ]; then for f in dist/allmydata-tahoe-*; do flappclient --furlfile ~/.tahoe-tarball-upload.furl upload-file $$f; done ; else echo not uploading tarballs because this is not trunk but is branch \"${BB_BRANCH}\" ; fi
 
 # DEBIAN PACKAGING
 
-VER=$(shell $(PYTHON) misc/get-version.py)
+VER=$(shell $(PYTHON) misc/build_helpers/get-version.py)
 DEBCOMMENTS="'make deb' build"
 
 show-version:
@@ -308,7 +301,7 @@
 .PHONY: deb-etch deb-lenny deb-sid
 .PHONY: deb-edgy deb-feisty deb-gutsy deb-hardy deb-intrepid deb-jaunty
 
-# we use misc/$TAHOE_ARCH/debian
+# we use misc/debian_helpers/$TAHOE_ARCH/debian
 
 deb-etch:      # py2.4
 	$(MAKE) deb-ARCH ARCH=etch TAHOE_ARCH=etch
@@ -337,7 +330,3 @@
 
 ifeq ($(findstring x-$(ARCH)-x,$(foreach arch,$(KNOWN_DEBIAN_ARCHES),"x-$(arch)-x")),)
 is-known-debian-arch:
-	@echo "ARCH must be set when using setup-deb or deb-ARCH"
-	@echo "I know how to handle:" $(KNOWN_DEBIAN_ARCHES)
-	false
-else

=== docs/Makefile ===

SOURCES = subtree1.svg lease-tradeoffs.svg

PNGS = $(patsubst %.svg,%.png,$(SOURCES))
EPSS = $(patsubst %.svg,%.eps,$(SOURCES))

.PHONY: images-png images-eps
all: $(PNGS) $(EPSS)
images-png: $(PNGS)
images-eps: $(EPSS)

%.png: %.svg
	inkscape -b white -d 90 -D --export-png $@ $<
%.eps: %.svg
	inkscape --export-eps $@ $<

clean:
	rm -f *.png *.eps

=== mac/Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
 ifdef UPLOAD_DEST_FURLFILE
 # N.B.: xfer-client.py requires foolscap, so we hack up PYTHONPATH to improve
 # the chances of finding it (using the one that we just built)
+# broken. To fix this just use flappclient. --Zooko 2010-06-06
 upload:
 	chmod a+r Allmydata-$(VERSION).dmg
 	PYTHONPATH=$(PYTHONPATH):../support/lib/python2.5/site-packages \

=== windows/Makefile ===

# we get $(PYTHON) from our parent, do 'make windows-exe PYTHON=foo' to
# control it, since 'PYTHON=foo make windows-exe' doesn't seem to override
# the default.

# We also get $(PYTHONPATH) from our parent, which is critical for py2exe to
# find the tahoe code. Invoking this Makefile directly won't work.

INNOSETUP := $(shell cygpath -au "$(PROGRAMFILES)/Inno Setup 5/Compil32.exe")

.PHONY: windows-exe windows-installer windows-installer-upload

windows-exe.stamp:
	$(PYTHON) setup.py py2exe
	touch windows-exe.stamp
windows-exe: windows-exe.stamp

windows-installer: windows-exe.stamp
	$(PYTHON) ../misc/sub-ver.py installer.tmpl >installer.iss
	"$(INNOSETUP)" /cc installer.iss

windows-installer-upload:
	chmod -R o+rx dist/installer
	rsync -av -e /usr/bin/ssh dist/installer/ amduser@dev:/home/amduser/public_html/dist/tahoe/windows/

=== debian/changelog ===
tahoe-lafs (1.7.1-0ubuntu1) maverick; urgency=low

  * Update to version 1.7.1 (LP: #609755).
    - SFTP support
    - support for non-ASCII character encodings
    - more checks to make sure file hunks are more sufficiently distributed
    - many bugfixes

 -- Paul Hummer <paul@ubuntu.com>  Tue, 10 Aug 2010 17:48:58 -0600

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Brian Warner <warner@lothar.com>
 Build-Depends: debhelper (>= 7), python-support, python-setuptools,
- python (>= 2.5)
+ python (>= 2.5), python-twisted
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
 Homepage: http://allmydata.org/trac/tahoe

## tahoe-lafs 1.8.2

=== debian/changelog ===
tahoe-lafs (1.8.2-0ubuntu1) natty; urgency=low

  * Update to version 1.8.2 (LP: #719092)
    - Improved performance and fault tolerance of downloads
    - Increased logging 
    - Fixed Twisted 10.2 compatitibility
  * Update standards version to 3.9.1

 -- Paul Hummer <paul@ubuntu.com>  Wed, 23 Feb 2011 13:58:35 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 7), python-support, python-setuptools,
  python (>= 2.5), python-twisted
 XS-Python-Version: >= 2.5
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Homepage: http://allmydata.org/trac/tahoe
 
 Package: tahoe-lafs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

package=tahoe-lafs

clean:
	rm -f build-*
	dh_testdir
	dh_testroot
	python setup.py clean
	rm -rf build
	find . -name "*\.py[co]" -exec rm -f {} \;
	dh_clean

build: build-indep

build-indep:
	touch $@

build-stamp: 
	dh_testdir
	python setup.py build
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	python setup.py install \
		--no-compile \
		--install-layout=deb \
		--single-version-externally-managed \
		--root $(CURDIR)/debian/$(package)

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
#	mv debian/$(package)/usr/share/doc/$(package)/CHANGES.txt \
#		debian/$(package)/usr/share/doc/$(package)/changelog
	dh_installexamples
	dh_strip
	dh_compress -X.py
	dh_fixperms
	dh_pysupport
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch:

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## tahoe-lafs 1.8.3

=== Makefile ===
--- 
+++ 
@@ -11,6 +11,7 @@
 
 PP=$(shell $(PYTHON) setup.py -q show_pythonpath)
 RUNPP=$(PYTHON) setup.py run_with_pythonpath
+TAHOE=$(PYTHON) bin/tahoe
 
 .PHONY: make-version build
 
@@ -48,18 +49,6 @@
 src/allmydata/_version.py:
 	$(MAKE) make-version
 
-# c.f. ticket #455, there is a problem in the intersection of setuptools,
-# twisted's setup.py, and nevow's setup.py . A Tahoe build, to satisfy its
-# dependencies, may try to build both Twisted and Nevow. If both of these
-# occur during the same invocation of 'setup.py develop', then the Nevow
-# build will fail with an "ImportError: No module named components". Running
-# the build a second time will succeed. Until there is a new version of
-# setuptools which properly sandboxes sys.modules (or a new version of nevow
-# which doesn't import twisted during its build, or a new version of twisted
-# which doesn't import itself during its build), we just build tahoe twice
-# and ignore the errors from the first pass. Updated 16-Sep-2008: now we need
-# three invocations.
-
 build: src/allmydata/_version.py
 	$(PYTHON) setup.py build
 	touch .built
@@ -116,45 +105,36 @@
 
 test-coverage: build src/allmydata/_version.py
 	rm -f .coverage
-	$(PYTHON) setup.py trial --reporter=bwverbose-coverage -s $(TEST)
+	$(TAHOE) debug trial --reporter=bwverbose-coverage $(TEST)
 
 quicktest:
-	$(PYTHON) misc/build_helpers/run-with-pythonpath.py trial $(TRIALARGS) $(TEST)
+	$(TAHOE) debug trial $(TRIALARGS) $(TEST)
 
 # code-coverage: install the "coverage" package from PyPI, do "make
 # quicktest-coverage" to do a unit test run with coverage-gathering enabled,
 # then use "make coverate-output-text" for a brief report, or "make
 # coverage-output" for a pretty HTML report. Also see "make .coverage.el" and
-# misc/coding_helpers/coverage.el for emacs integration.
+# misc/coding_tools/coverage.el for emacs integration.
 
 quicktest-coverage:
 	rm -f .coverage
-	$(PYTHON) misc/build_helpers/run-with-pythonpath.py trial --reporter=bwverbose-coverage $(TEST)
+	$(TAHOE) debug trial --reporter=bwverbose-coverage $(TEST)
 # on my laptop, "quicktest" takes 239s, "quicktest-coverage" takes 304s
 
+# --include appeared in coverage-3.4
+COVERAGE_OMIT=--include '$(CURDIR)/src/allmydata/*' --omit '$(CURDIR)/src/allmydata/test/*'
 coverage-output:
 	rm -rf coverage-html
-	coverage html -d coverage-html
+	coverage html -i -d coverage-html $(COVERAGE_OMIT)
 	cp .coverage coverage-html/coverage.data
 	@echo "now point your browser at coverage-html/index.html"
-
-## use these two targets to compare this coverage against the previous run.
-## The deltas only work if the old test was run in the same directory, since
-## it compares absolute filenames.
-#get-old-figleaf-coverage:
-#	wget --progress=dot -O old.figleaf http://allmydata.org/tahoe-figleaf/current/figleaf.pickle
-#
-#figleaf-delta-output:
-#	$(RUNPP) -p -c "misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes -o old.figleaf"
-#	cp .figleaf coverage-html/figleaf.pickle
-#	@echo "now point your browser at coverage-html/index.html"
 
 .PHONY: upload-coverage .coverage.el pyflakes count-lines
 .PHONY: check-memory check-memory-once check-speed check-grid
 .PHONY: repl test-darcs-boringfile test-clean clean find-trailing-spaces
 
 .coverage.el: .coverage
-	$(PYTHON) misc/coding_helpers/coverage2el.py
+	$(PYTHON) misc/coding_tools/coverage2el.py
 
 # 'upload-coverage' is meant to be run with an UPLOAD_TARGET=host:/dir setting
 ifdef UPLOAD_TARGET
@@ -177,7 +157,9 @@
 
 
 pyflakes:
-	$(PYTHON) -OOu `which pyflakes` src/allmydata |sort |uniq
+	$(PYTHON) -OOu `which pyflakes` src/allmydata static misc/build_helpers bin/tahoe-script.template twisted setup.py |sort |uniq
+check-umids:
+	$(PYTHON) misc/coding_tools/check-umids.py `find src/allmydata -name '*.py'`
 
 count-lines:
 	@echo -n "files: "
@@ -215,11 +197,11 @@
 check-speed: .built
 	if [ -z '$(TESTCLIENTDIR)' ]; then exit 1; fi
 	@echo "stopping any leftover client code"
-	-$(PYTHON) bin/tahoe stop $(TESTCLIENTDIR)
-	$(PYTHON) bin/tahoe start $(TESTCLIENTDIR)
+	-$(TAHOE) stop $(TESTCLIENTDIR)
+	$(TAHOE) start $(TESTCLIENTDIR)
 	sleep 5
 	$(PYTHON) src/allmydata/test/check_speed.py $(TESTCLIENTDIR)
-	$(PYTHON) bin/tahoe stop $(TESTCLIENTDIR)
+	$(TAHOE) stop $(TESTCLIENTDIR)
 
 # The check-grid target also uses a pre-established client node, along with a
 # long-term directory that contains some well-known files. See the docstring
@@ -234,17 +216,17 @@
 # 'make repl' is a simple-to-type command to get a Python interpreter loop
 # from which you can type 'import allmydata'
 repl:
-	$(RUNPP) -p
+	$(TAHOE) debug repl
 
 test-darcs-boringfile:
 	$(MAKE)
 	$(PYTHON) misc/build_helpers/test-darcs-boringfile.py
 
 test-clean:
-	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.old
+	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|appname).py" |sort >allfiles.tmp.old
 	$(MAKE)
 	$(MAKE) clean
-	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|auto_deps|appname).py" |sort >allfiles.tmp.new
+	find . |grep -vEe "_darcs|allfiles.tmp|src/allmydata/_(version|appname).py" |sort >allfiles.tmp.new
 	diff allfiles.tmp.old allfiles.tmp.new
 
 clean:
@@ -252,11 +234,11 @@
 	rm -f `find src *.egg -name '*.so' -or -name '*.pyc'`
 	rm -rf src/allmydata_tahoe.egg-info
 	rm -rf support dist
-	rm -rf `ls -d *.egg | grep -vEe"setuptools-|setuptools_trial-|darcsver-"`
+	rm -rf `ls -d *.egg | grep -vEe"setuptools-|setuptools_darcs-|darcsver-"`
 	rm -rf *.pyc
 	rm -rf misc/dependencies/build misc/dependencies/temp
 	rm -rf misc/dependencies/tahoe_deps.egg-info
-	rm -f bin/tahoe bin/tahoe-script.py
+	rm -f bin/tahoe bin/tahoe.pyscript
 
 find-trailing-spaces:
 	$(PYTHON) misc/coding_tools/find-trailing-spaces.py -r src
@@ -267,7 +249,7 @@
 # support/lib/ directory is gone.
 
 fetch-and-unpack-deps:
-	test -f tahoe-deps.tar.gz || wget http://allmydata.org/source/tahoe/deps/tahoe-deps.tar.gz
+	test -f tahoe-deps.tar.gz || wget http://tahoe-lafs.org/source/tahoe/deps/tahoe-deps.tar.gz
 	rm -rf tahoe-deps
 	tar xzf tahoe-deps.tar.gz
 
@@ -285,7 +267,7 @@
 	$(PYTHON) setup.py sdist --sumo --formats=bztar,gztar,zip
 
 upload-tarballs:
-	@if [ "X${BB_BRANCH}" == "Xtrunk" ]; then for f in dist/allmydata-tahoe-*; do flappclient --furlfile ~/.tahoe-tarball-upload.furl upload-file $$f; done ; else echo not uploading tarballs because this is not trunk but is branch \"${BB_BRANCH}\" ; fi
+	@if [ "X${BB_BRANCH}" == "Xtrunk" ] || [ "X${BB_BRANCH}" == "X" ]; then for f in dist/allmydata-tahoe-*; do flappclient --furlfile ~/.tahoe-tarball-upload.furl upload-file $$f; done ; else echo not uploading tarballs because this is not trunk but is branch \"${BB_BRANCH}\" ; fi
 
 # DEBIAN PACKAGING
 
@@ -330,3 +312,39 @@
 
 ifeq ($(findstring x-$(ARCH)-x,$(foreach arch,$(KNOWN_DEBIAN_ARCHES),"x-$(arch)-x")),)
 is-known-debian-arch:
+	@echo "ARCH must be set when using setup-deb or deb-ARCH"
+	@echo "I know how to handle:" $(KNOWN_DEBIAN_ARCHES)
+	false
+else
+is-known-debian-arch:
+	true
+endif
+
+ifndef TAHOE_ARCH
+TAHOE_ARCH=$(ARCH)
+endif
+
+setup-deb: is-known-debian-arch
+	rm -f debian
+	ln -s misc/debian_helpers/$(TAHOE_ARCH)/debian debian
+	chmod +x debian/rules
+
+# etch (current debian stable) has python-simplejson-1.3, which doesn't
+#  support indent=
+# sid (debian unstable) currently has python-simplejson 1.7.1
+# edgy has 1.3, which doesn't support indent=
+# feisty has 1.4, which supports indent= but emits a deprecation warning
+# gutsy has 1.7.1
+#
+# we need 1.4 or newer
+
+deb-ARCH: is-known-debian-arch setup-deb
+	fakeroot debian/rules binary
+	@echo
+	@echo "The newly built .deb packages are in the parent directory from here."
+
+.PHONY: increment-deb-version
+.PHONY: deb-etch-head deb-lenny-head deb-sid-head
+.PHONY: deb-edgy-head deb-feisty-head deb-gutsy-head deb-hardy-head deb-intrepid-head deb-jaunty-head
+
+# The buildbot runs the following targets after each change, to produce

=== debian/changelog ===
tahoe-lafs (1.8.3-2) unstable; urgency=high

  [ Bert Agaz ]
  * Fix dependency regression against python-twisted (Closes: #641649).

 -- Micah Anderson <micah@debian.org>  Thu, 15 Sep 2011 17:20:56 +0200

tahoe-lafs (1.8.3-1) unstable; urgency=high

  [ Bert Agaz ]
  * New upstream release (Closes: #641540), urgency high due to security fix
  * Refresh Debian patches.
  * Add header to Debian patches.
  * Remove Debian version of python-pycryptopp dependency (Closes: #630825).
  * Remove python-twisted dependency.
    python-foolscap already depends on the needed twisted packages.
  * Remove link to /usr/share/common-licenses/BSD.
  * Add Vcs-{Git,Browser} to debian/control.
  * Add a patch to reduce Twisted dependencies (Closes: #631163).
    (credit goes to Julian Taylor <jtaylor.debian@googlemail.com>).

 -- Micah Anderson <micah@debian.org>  Tue, 21 Jun 2011 14:01:31 +0200

tahoe-lafs (1.8.2-3) unstable; urgency=low

  * Update debian/copyright to have complete licensing information

 -- Micah Anderson <micah@debian.org>  Thu, 16 Jun 2011 13:33:31 -0400

tahoe-lafs (1.8.2-2) unstable; urgency=low

  * Raise dependency on python-pycryptopp version, now upgraded in Debian. 

 -- Bert Agaz <bertagaz@ptitcanardnoir.org>  Wed, 15 Jun 2011 00:41:24 +0200

tahoe-lafs (1.8.2-1) unstable; urgency=low

  [ bertagaz ]
  * Initial release (Closes: #544338).
  * Remove ubuntu's specific XSBC-Original-Maintainer field a in debian/control.
  * Remove deprecated XB-Python-Version field in debian/control.
  * Add install dependency on python-mock.
  * Update homepage in debian/control.
  * Ignore quilt dir.
  * Remove upstream custom build dependencies.
  * Include munin plugins.
  * Use upstream trick to install a clean bin/tahoe.
  * Bump versions of several install dependencies.
  * Bump compatibility version.
  * Exclude buildtest python package from the debian one.

  [ Micah Anderson]
  * switch dh_clean -k to dh_prep
  * add myself to Uploaders
  * Update Standards-Version: no changes

 -- Bert Agaz <bertagaz@ptitcanardnoir.org>  Wed, 13 Apr 2011 21:35:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: tahoe-lafs
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Brian Warner <warner@lothar.com>
+Maintainer: Bert Agaz <bertagaz@ptitcanardnoir.org>
+Uploaders: Micah Anderson <micah@debian.org>
 Build-Depends: debhelper (>= 7), python-support, python-setuptools,
  python (>= 2.5), python-twisted
 XS-Python-Version: >= 2.5
-Standards-Version: 3.9.1
-Homepage: http://allmydata.org/trac/tahoe
+Standards-Version: 3.9.2
+Vcs-Git: git://anonscm.debian.org/tahoe/tahoe.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=tahoe/tahoe.git
+Homepage: http://tahoe-lafs.org/trac/tahoe
 
 Package: tahoe-lafs
 Architecture: all
-Depends: ${misc:Depends}, ${python:Depends}, python-twisted,
- python-foolscap (>= 0.4.1), python-openssl, python-nevow,
- python-simplejson (>= 1.4), python-zfec (>= 1.1), python-pycryptopp (>= 0.5.14),
- python-setuptools
-XB-Python-Version: >= 2.5
+Depends: ${misc:Depends}, ${python:Depends}, python-pyasn1, python-crypto,
+ python-foolscap (>= 0.6.1-3), python-openssl, python-nevow,
+ python-simplejson (>= 2.1.1), python-zfec (>= 1.4), python-pycryptopp (>= 0.5.29),
+ python-setuptools, python-mock, python-twisted
 Description: Secure distributed filesystem
  Tahoe, the Least Authority File System, is a distributed filesystem that
  features high reliability, strong security properties, and a fine-grained

=== debian/rules ===
--- 
+++ 
@@ -15,10 +15,11 @@
 	find . -name "*\.py[co]" -exec rm -f {} \;
 	dh_clean
 
-build: build-indep
+build: build-indep build-arch
 
-build-indep:
-	touch $@
+build-arch: build-stamp
+
+build-indep: build-stamp
 
 build-stamp: 
 	dh_testdir
@@ -28,21 +29,30 @@
 install: build
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
+	dh_install
+	chmod 755 debian/$(package)/usr/share/munin/plugins/*
 	python setup.py install \
 		--no-compile \
 		--install-layout=deb \
 		--single-version-externally-managed \
 		--root $(CURDIR)/debian/$(package)
+	
+	# Clean bin/tahoe trick stolen from upstream packaging script.
+	head -1 debian/$(package)/usr/bin/tahoe > debian/$(package)/usr/bin/tahoe.new
+	echo "from allmydata.scripts import runner" >> debian/$(package)/usr/bin/tahoe.new
+	echo "runner.run()" >> debian/$(package)//usr/bin/tahoe.new
+	chmod +x debian/$(package)/usr/bin/tahoe.new
+	mv debian/$(package)/usr/bin/tahoe.new debian/$(package)/usr/bin/tahoe
 
 binary-indep: build install
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-#	mv debian/$(package)/usr/share/doc/$(package)/CHANGES.txt \
-#		debian/$(package)/usr/share/doc/$(package)/changelog
+	mv debian/$(package)/usr/share/doc/$(package)/NEWS \
+		debian/$(package)/usr/share/doc/$(package)/changelog
 	dh_installexamples
 	dh_strip
 	dh_compress -X.py

## tahoe-lafs 1.9.1

=== debian/changelog ===
tahoe-lafs (1.9.1-1) unstable; urgency=high

  [ Bert Agaz ]
  * New upstream release (Closes: #652002).
  * Set urgency to high due to RC bug fix.
  * Update debian/patches/.
  * Install munin plugin configuration as examples (Closes: #652106).
  * Remove old deps version numbers from debian/control.
  * Update debian/copyright to follow DEP-5.
  * Bump debian standard version to 3.9.3.
  * Add manpage.
  * Switch to dh_python2.
  * Bump debian/compat.
  * Fix setuptools egg_info mess with upstream sources. (Closes: #653312)

 -- Micah Anderson <micah@debian.org>  Tue, 12 Jun 2012 09:35:12 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: optional
 Maintainer: Bert Agaz <bertagaz@ptitcanardnoir.org>
 Uploaders: Micah Anderson <micah@debian.org>
-Build-Depends: debhelper (>= 7), python-support, python-setuptools,
- python (>= 2.5), python-twisted
-XS-Python-Version: >= 2.5
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), python-setuptools, python-all (>= 2.6.6-3~),
+ python-twisted
+Standards-Version: 3.9.3
 Vcs-Git: git://anonscm.debian.org/tahoe/tahoe.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=tahoe/tahoe.git
 Homepage: http://tahoe-lafs.org/trac/tahoe
@@ -14,9 +13,9 @@
 Package: tahoe-lafs
 Architecture: all
 Depends: ${misc:Depends}, ${python:Depends}, python-pyasn1, python-crypto,
- python-foolscap (>= 0.6.1-3), python-openssl, python-nevow,
- python-simplejson (>= 2.1.1), python-zfec (>= 1.4), python-pycryptopp (>= 0.5.29),
- python-setuptools, python-mock, python-twisted
+ python-foolscap, python-openssl, python-nevow, python-simplejson,
+ python-zfec, python-pycryptopp (>= 0.5.29), python-setuptools, python-mock,
+ python-twisted
 Description: Secure distributed filesystem
  Tahoe, the Least Authority File System, is a distributed filesystem that
  features high reliability, strong security properties, and a fine-grained
